define("io.ox/backbone/mini-views/alarms",["io.ox/calendar/util","io.ox/backbone/views/disposable","gettext!io.ox/calendar","settings!io.ox/calendar","less!io.ox/backbone/mini-views/alarms"],function(t,e,a,i){"use strict";var r=["DISPLAY","AUDIO","EMAIL"],n=i.get("availableAlarmTypes",r),l={DISPLAY:a("Notification"),AUDIO:a("Audio"),EMAIL:a("Mail")},o={"START-":a("before start"),START:a("after start"),"END-":a("before end"),END:a("after end")},s={"DISPLAYSTART-":a("Notify %1$s before start."),DISPLAYSTART:a("Notify %1$s after start."),"DISPLAYEND-":a("Notify %1$s before end."),DISPLAYEND:a("Notify %1$s after end."),DISPLAYABS:a("Notify at %1$s."),DISPLAYSTART0:a("Notify at start."),DISPLAYEND0:a("Notify at end."),"AUDIOSTART-":a("Play sound %1$s before start."),AUDIOSTART:a("Play sound %1$s after start."),"AUDIOEND-":a("Play sound %1$s before end."),AUDIOEND:a("Play sound %1$s after end."),AUDIOABS:a("Play sound at %1$s."),AUDIOSTART0:a("Play sound at start."),AUDIOEND0:a("Play sound at end."),"EMAILSTART-":a("Send mail %1$s before start."),EMAILSTART:a("Send mail %1$s after start."),"EMAILEND-":a("Send mail %1$s before end."),EMAILEND:a("Send mail %1$s after end."),EMAILABS:a("Send mail at %1$s."),EMAILSTART0:a("Send mail at start."),EMAILEND0:a("Send mail at end."),"GENERICSTART-":a("%1$s %2$s before start."),GENERICSTART:a("%1$s %2$s after start."),"GENERICEND-":a("%1$s %2$s before end."),GENERICEND:a("%1$s %2$s after end."),GENERICABS:a("%1$s at %2$s."),GENERICSTART0:a("%1$s at start."),GENERICEND0:a("%1$s at end.")},d=e.extend({className:"alarms-view",events:{"click .alarm-remove":"onRemove","change .alarm-action":"updateModel","change .alarm-time":"updateModel","change .alarm-related":"updateModel"},initialize:function(t){this.options=t||{},this.attribute=t.attribute||"alarms",this.list=$('<div class="alarm-list">'),this.model&&this.listenTo(this.model,"change:"+this.attribute,this.updateView)},render:function(){var e=this;return this.$el.empty().append(e.list,$('<button class="btn btn-default" type="button">').text(a("Add reminder")).on("click",function(){var a;a="alarms"===e.attribute&&e.model?t.isAllday(e.model)?"-PT12H":"-PT15M":"chronos/defaultAlarmDate"===e.attribute||"birthdays/defaultAlarmDate"===e.attribute?"-PT12H":"-PT15M";var i=e.createNodeFromAlarm({action:"DISPLAY",trigger:{duration:a,related:"START"}});e.list.append(i),i.find(".alarm-action").focus(),e.updateModel()})),this.updateView(),this},onRemove:function(t){t.stopPropagation(),$(arguments[0].target).closest(".alarm-list-item").remove(),this.updateModel()},updateModel:function(){this.model&&(this.changedByUser=!0,this.model.set(this.attribute,this.getAlarmsArray()),this.changedByUser=!1)},updateView:function(){if(!this.changedByUser){var t=this;this.list.empty().append(this.model?_(this.model.get(this.attribute)).map(t.createNodeFromAlarm.bind(t)):[])}},createNodeFromAlarm:function(e,i){if(i=(i||this.list.children().length)+1,e&&e.trigger){var r,s,d=_.uniqueId();if(s=$('<fieldset class="alarm-list-item">').data("id",e.uid).append($('<legend class="sr-only">').text(a("Reminder %1$d",i)),r=$('<div class="item">')),-1===_(n).indexOf(e.action)?r.append($('<div class="alarm-action" tabindex="0">').text(l[e.action]||e.action).val(e.action)):r.append($('<label class="sr-only">').attr("for","action-"+d).text(a("type")),$('<select class="form-control alarm-action">').attr("id","action-"+d).append(_(n).map(function(t){return $("<option>").text(l[t]).val(t)})).val(e.action)),e.trigger.duration){var m,u;r.append($('<label class="sr-only">').attr("for","time-"+d).text(a("timeframe")),m=$('<select class="form-control alarm-time">').attr("id","time-"+d).append(_.map(t.getReminderOptions(),function(t,e){return'<option value="'+e+'">'+t+"</option>"})),$('<label class="sr-only">').attr("for","related-"+d).text(a("timeframe relation")),u=$('<select class="form-control alarm-related">').attr("id","related-"+d).append(_.map(o,function(t,e){return'<option value="'+e+'">'+t+"</option>"}))),-1===_(_(t.getReminderOptions()).keys()).indexOf(e.trigger.duration.replace("-",""))&&(/^[-+]?PT0[SHDW]$/.test(e.trigger.duration)?m.find('[value="PT0M"]').val(e.trigger.duration.replace("-","")):m.append($("<option>").val(e.trigger.duration.replace("-","")).text(new moment.duration(e.trigger.duration).humanize()))),u.val((e.trigger.related||"START")+e.trigger.duration.replace(/\w*/g,"")),m.val(e.trigger.duration.replace("-",""))}else r.append($('<div class="alarm-time" tabindex="0">').text(new moment(e.trigger.dateTime).format("LLL")).val(e.trigger.dateTime));return r.append($('<button type="button" class="btn btn-link alarm-remove">').attr("aria-label",a("Remove reminder")).append($('<i class="fa fa-trash">'))),s}},getAlarmsArray:function(){var t=this;return _(this.list.children()).map(function(e){var a={action:$(e).find(".alarm-action").val()},i=$(e).find(".alarm-time").val(),r=$(e).find(".alarm-related").val();switch(0===i.indexOf("-P")||0===i.indexOf("P")?a.trigger={duration:r.replace(/\w*/g,"")+i,related:r.replace(/\W*/g,"")}:a.trigger={dateTime:i},$(e).data("id")&&(a=_.extend(_(t.model.get("alarms")).findWhere({uid:$(e).data("id")}),a)),a.action){case"DISPLAY":a.description||(a.description=t.model?t.model.get("summary")||"reminder":"reminder")}return a})}});return{linkView:e.extend({className:"alarms-link-view",events:{"click .alarm-link":"openDialog"},initialize:function(t){this.options=t||{},this.attribute=t.attribute||"alarms",this.model&&this.listenTo(this.model,"change:"+this.attribute,this.render)},render:function(){return this.$el.empty().append(0===(this.model.get(this.attribute)||[]).length?$('<button type="button" class="alarm-link btn btn-link">').text(a("No reminder")):this.drawList()),this},drawList:function(){var e=$('<ul class="list-unstyled alarm-link-list">');return _(this.model.get(this.attribute)).each(function(i){if(i&&i.trigger){var n,l=[];-1===_(r).indexOf(i.action)?(l.push(i.action),n="GENERIC"):n=i.action,i.trigger.duration?(l.push(t.getReminderOptions()[i.trigger.duration.replace("-","")]||new moment.duration(i.trigger.duration).humanize()),n=n+(i.trigger.related||"START")+(-1===i.trigger.duration.indexOf("PT0")?i.trigger.duration.replace(/\w*/g,""):"0")):(l.push(new moment(i.trigger.dateTime).format("LLL")),n+="ABS"),l.unshift(s[n]),e.append($("<li>").append($('<button type="button" class="alarm-link btn btn-link">').text(a.format.apply(void 0,l))))}}),e},openDialog:function(){var t=this;require(["io.ox/backbone/views/modal"],function(e){var i,r={};r[t.attribute]=_.deepClone(t.model.get(t.attribute)),i=new d({model:new Backbone.Model(r),attribute:t.attribute}),new e({title:a("Edit reminders"),width:600}).build(function(){this.$body.append(i.render().$el),this.$el.addClass("alarms-view-dialog")}).addCancelButton({left:!0}).addButton({action:"apply",label:a("Apply")}).on("apply",function(){t.model.trigger("userChangedAlarms"),t.model.set(t.attribute,i.getAlarmsArray()).trigger("change:"+t.attribute)}).open()})}}),alarmsView:d}});